DRBG-0.5.5: Deterministic random bit generator (aka RNG, PRNG) based HMACs, Hashes, and Ciphers.

Safe Haskell | None
Language | Haskell2010

Crypto.Random.DRBG.Hash

# Documentation

data State d Source #

#### Instances

Instances details

CryptoRandomGen HashDRBG Source # |

Instance details

Defined in Crypto.Random.DRBG

Methods

newGen :: ByteString -> Either GenError HashDRBG Source #

genSeedLength :: Tagged HashDRBG ByteLength Source #

genBytes :: ByteLength -> HashDRBG -> Either GenError (ByteString, HashDRBG) Source #

reseedInfo :: HashDRBG -> ReseedInfo Source #

reseedPeriod :: HashDRBG -> ReseedInfo Source #

genBytesWithEntropy :: ByteLength -> ByteString -> HashDRBG -> Either GenError (ByteString, HashDRBG) Source #

reseed :: ByteString -> HashDRBG -> Either GenError HashDRBG Source #

newGenIO :: IO HashDRBG Source #

counter :: State d -> Word64 Source #

reseedInterval :: Word64 Source #

class SeedLength h where Source #

Methods

seedlen :: Tagged h Int Source #

#### Instances

Instances details

SeedLength SHA1 Source # |
Instance details Defined in Crypto.Random.DRBG Methods seedlen :: Tagged SHA1 Int Source #
SeedLength SHA224 Source # |
Instance details Defined in Crypto.Random.DRBG Methods seedlen :: Tagged SHA224 Int Source #
SeedLength SHA256 Source # |
Instance details Defined in Crypto.Random.DRBG Methods seedlen :: Tagged SHA256 Int Source #
SeedLength SHA384 Source # |
Instance details Defined in Crypto.Random.DRBG Methods seedlen :: Tagged SHA384 Int Source #
SeedLength SHA512 Source # |
Instance details Defined in Crypto.Random.DRBG Methods seedlen :: Tagged SHA512 Int Source #

instantiate :: (Hash c d, SeedLength d) => Entropy -> Nonce -> PersonalizationString -> State d Source #

reseed :: (SeedLength d, Hash c d) => State d -> Entropy -> AdditionalInput -> State d Source #

generate :: (Hash c d, SeedLength d) => State d -> BitLen -> AdditionalInput -> Maybe (RandomBits, State d) Source #